﻿Imports FarPoint.Win.Spread.CellType

Public Class Form1
    Dim cmbCountry As ComboBoxCellType = Nothing
    Dim cmbLang As ComboBoxCellType = Nothing

    'Set the Width of Column 3 based on longest item's Width
    '
    Private Function getWidth() As Single
        Dim _fTotalWidth As Single = 0
        For _iCount As Integer = 0 To cmbCountry.Items.Count() - 1
            If _fTotalWidth < Me.CreateGraphics().MeasureString(cmbCountry.Items(_iCount), New Font("Microsoft Sans Serif", 8.25F)).Width Then
                _fTotalWidth = Me.CreateGraphics().MeasureString(cmbCountry.Items(_iCount), New Font("Microsoft Sans Serif", 8.25F)).Width
            End If
        Next
        _fTotalWidth = _fTotalWidth + SystemInformation.VerticalScrollBarWidth
        Return _fTotalWidth
    End Function
    '
    'Set the Width of Column 2 based on selected item's Width
    '
    Private Sub FpSpread1_ComboCloseUp_1(sender As System.Object, e As FarPoint.Win.Spread.EditorNotifyEventArgs) Handles FpSpread1.ComboCloseUp
        If e.Column = 1 And FpSpread1.ActiveSheet.ActiveCell.Text <> [String].Empty Then
            cmbLang.StopEditing()
            FpSpread1.ActiveSheet.Columns(1).Width = FpSpread1.ActiveSheet.GetPreferredColumnWidth(1)
        End If
    End Sub

    Private Sub Form1_Load_1(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        '
        'Set the Label of ColumnHeader
        '
        FpSpread1.ActiveSheet.ColumnHeader.Columns(0).Label = "Name"
        FpSpread1.ActiveSheet.ColumnHeader.Columns(1).Label = "Language"
        FpSpread1.ActiveSheet.ColumnHeader.Columns(2).Label = "Country"

        '
        'Create ComboBoxCellType
        '
        cmbCountry = New ComboBoxCellType()
        cmbLang = New ComboBoxCellType()


        cmbCountry.Items = New String() {"India", "South Australia", "China", "USA"}
        cmbLang.Items = New String() {"Hindi-India(IN)", "English-Australia(AU)", "Urdu-PK", "Chinese-ZN"}

        '
        ' Set the CellType as ComboBoxCellType
        '
        For row = 0 To 5

            FpSpread1.ActiveSheet.Cells(row, 1).CellType = cmbLang
            FpSpread1.ActiveSheet.Cells(row, 2).CellType = cmbCountry
        Next


        '
        'Fill data in Spread Sheet
        '

        FpSpread1.ActiveSheet.Cells(0, 0).Text = "Jack"
        FpSpread1.ActiveSheet.Cells(1, 0).Text = "Denial"
        FpSpread1.ActiveSheet.Cells(2, 0).Text = "Johnson Andrew"
        FpSpread1.ActiveSheet.Cells(3, 0).Text = "John Peter"
        FpSpread1.ActiveSheet.Cells(4, 0).Text = "John cena"
        FpSpread1.ActiveSheet.Cells(5, 0).Text = "John A"


        FpSpread1.ActiveSheet.Columns(0).Width = FpSpread1.ActiveSheet.GetPreferredColumnWidth(0)
        FpSpread1.ActiveSheet.Columns(2).Width = getWidth()

    End Sub
End Class
